<template>
  <div style="height: 80vh;overflow-y: auto;">
    <div style="display: flex;justify-content: end;margin-bottom: 5px;">
      <el-button type="primary" v-loading="loadingShow" @click="onloadExcel">
        <el-icon>
          <Download />
        </el-icon>
        <span>导出</span>
      </el-button>
    </div>
    <MOSTY.PageTree :searchType="'03'" :isShowLeftTree="false">

      <template #serach>
      </template>
      <template #table>
        <section :style="{ 'height': totalHeight }">
          <MOSTY.Table :table-columns="tableColumns" :tableData="tableData" :tableloading="tableloading"
            :isSelect="false" :isSort="false" :tableHeight="'100%'" :actionsW="300">
            <template #ctype="{ row }">
              <dict-tag v-if="row.ctype" :options="D_BZ_YSFYLB" :value="row.ctype" :tag="false" />
              <span v-else>无</span>
            </template>
            <template #cwkm="{ row }">
              <dict-tag v-if="row.cwkm" :options="D_TB_YSCWKU" :value="row.cwkm" :tag="false" />
              <span v-else>无</span>
            </template>
            <template #costFee="{ row }">
              {{ row.costFee || 0 }}
            </template>
            <template #state="{ row }">
              <dict-tag v-if="row.state" :options="stateOpt" :value="row.state" :tag="true" />
              <span v-else>无</span>
            </template>
            <template #actions="{ row }">
              <span class="operesee" @click="seeDetail(row)"><el-icon>
                  <Compass />
                </el-icon>查看明细</span>
            </template>
          </MOSTY.Table>
        </section>
        <div class="fenye">
          <MOSTY.Pages :pageConfiger="pageConfiger" @changeNo="handleCurrentChange" @changeSize="handleSizeChange" />
        </div>
      </template>

    </MOSTY.PageTree>
    <el-dialog :title="dialogTitle" v-model="isShowAuditDialog" width="90vw">
      <Audit :years="listQuery.years" :type="dialogType" :row="currRow" :title="dialogTitle"
        @close="auditDialogClose" />
    </el-dialog>
    <el-dialog :title="xgsTCTitle" v-model="isShowXgsTC" width="90vw">
      <xgsTC v-if="isShowXgsTC" :years="listQuery.years" :row="currRow" />
    </el-dialog>
    <AuditTimeLine v-if="isShowTimeLine" :years="listQuery.years" :row="currRow" @close="isShowTimeLine = false" />
  </div>
</template>

<script setup>
// 引入
import { reactive, onMounted, ref, getCurrentInstance, nextTick, watch, computed,defineProps } from 'vue'
import { ElMessage } from "element-plus";
import * as MOSTY from "@/components/MyComponents/index";
import { getApi, deleteApi, putApi, postApi } from "@/api/tobAcco_api.js";
import { exportXlsx, downloadImg } from "@/excel/Export2Excel.js";
import { getItem } from "@/utils/storage";
import { filterYear, filterqx } from "@/utils/auth.js";
import { numAdd } from "@/utils/tools.js";
import Audit from '../AuditTable.vue';
import AuditTimeLine from '../AuditTimeLine.vue';
import xgsTC from './xgsTC.vue';
// import SubmitAllAudit from './SubmitAllAudit.vue';
// import Sjtj from '@/views/dataReportWork/aqjypx/components/sjtj.vue'
import {
  getDept
} from "@/api/user-manage";
const { proxy } = getCurrentInstance();
const { D_BZ_YSFYLB, D_TB_YSCWKU } = proxy.$dict("D_BZ_YSFYLB", "D_TB_YSCWKU");
const props = defineProps(['years','row'])
const xgsTCTitle = ref('')
const isShowXgsTC = ref(false)

const sybmlist = ref([])
const loadingShow = ref(false);
const addplanShow = ref(false);
const addysShow = ref(false);
/** 当前层级 1省 2市 3县 */
const currLev = ref(3) // 1 省 2 市 3 县
/** 是否显示 审核弹框 */
const isShowAuditDialog = ref(false)
const isShowTimeLine = ref(false)
const isShowSubmitAllAudit = ref(false)
/** 当前时间是否是上半年 */
const isHalfYear = ref(new Date().getMonth() < 6);
/** 是否是县公司 */
const isxgs = ref(filterqx('isxgs') == '1')
/**市公司 */
const isgs = ref(filterqx('isgs') == '1')
/**省公司 */
const isSgs = ref(filterqx('isSgs') == '1')
/** 当前查看或审核行 */
const currRow = ref({})
const dialogType = ref('see') // see 查看  edit 编辑
const dialogTitle = ref('')
const searchArr = reactive([
  {
    showType: "year",
    prop: "years",
    width: '250px',
    defaultVal: new Date().getFullYear().toString(),

  },
  // {
  //   showType: "select",
  //   prop: "state",
  //   width: '250px',
  //   options: [
  //     { label: '年度预算', value: '0' },
  //     { label: '中期审核预算', value: '1' },

  //   ],
  //   placeholder: '请选择状态'
  // },
  // {
  //   showType: "select",
  //   prop: "state",
  //   width: '250px',
  //   //审批状态（0-未上报 1-县公司安全部门负责人 2-市州公司安全部门负责人审批 3-省局公司安全部门负责人审批 4-审批通过 5-被驳回
  //   options: [
  //     { label: '未上报', value: '0' },
  //     { label: '县公司安全部门负责人', value: '1' },
  //     { label: '市州公司安全部门负责人审批', value: '2' },
  //     { label: '省局公司安全部门负责人审批', value: '3' },
  //     { label: '审批通过', value: '4' },
  //     { label: '被驳回', value: '5' },
  //   ],
  //   placeholder: '请选择审核状态'
  // },

]);

const listQueryObj = ref({
  lev1Data: {},
  lev2Data: {},
  lev3Data: {},
})

const stateOpt = [
{ label: '未上报', value: '0', elTagType: 'ysshpf-oper-red' },
  { label: '部门已上报', value: '1' },
  { label: '县安全部门负责人审批', value: '2' },
  { label: '市安全部门负责人汇总', value: '3' },
  { label: '市安全部门负责人审核', value: '4' },
  { label: '省安全部门负责人审核', value: '5' },
  { label: '审批通过', value: '6' },
];

const tableloading = ref(false)
const USERID = getItem("USERID")
const ssdept = getItem("deptId")
const title = ref('');//弹窗标题
const type = ref('01');//控制弹窗参数(01:年初预算调整审核新增)
const rowid = ref(null)
const listQuery = reactive({
  pageCurrent: 1,
  pageSize: 20,
  years: new Date().getFullYear().toString(),
  orgid: null,
  ctype: null
});
const isOpen = ref(false);
const tableData = ref([])

const pageConfiger = reactive({
  pageSize: 20,
  pageCurrent: 1,
  total: 0
})
const tableColumns = reactive([
  {
    title: '部门',
    prop: 'orgname',
    width: '200',
    fixed: 'left',
  },
  // {
  //   title: "使用金额(万元)",
  //   prop: "costFee",
  //   width: '200',
  //   slot: true
  // },

  {
    title: "年初预算调整金额(万元)",
    prop: "budgetmoney",
    width: '160',
  },

  {
    title: "年初批复",
    prop: "budget",
    width: '160',
  },
  {
    title: "中期调整增减数",
    prop: "tzzj",
    width: '160',
  },
  {
    title: "中期归口审核增减数",
    prop: "gkshzj",
    // width: '160',
  },

  {
    title: "状态",
    prop: "state",
    // width: '180',
    fixed: 'right',
    slot: true
  },
  {
    title: "操作",
    prop: "actions",
    fixed: 'right',
    slot: true
  }
])

const deptid = ref(null)
const orgids = ref(null)
const totalHeight = ref(null)
const getHeight = ref(null)
watch(() => isOpen.value, (val) => {
  nextTick(() => {
    // if (val) {
    //   totalHeight.value = `calc(90vh - ${379 + getHeight.value.offsetHeight}px)`
    //   return
    // }
    totalHeight.value = `calc(80vh - 100px)`
  })
}, {
  deep: true,
  immediate: true
})
const auditDialogClose = () => {
  isShowAuditDialog.value = false
  getDataList()
}
onMounted(() => {
  getDataList()
})
//获取年初查询年初统计

//刷新
function resetTable(val) {
  listQuery.pageSize = 20
  listQuery.pageCurrent = 1
  // listQuery.orgid = orgids.value;
  // listQuery.ctype = ''
  deptid.value = ''
  listQuery.years = new Date().getFullYear().toString()
  getDataList();
}

//查询
function onSearch(obj) {
  listQuery.pageCurrent = 1
  // listQuery.ctype = obj.ctype;
  listQuery.years = obj.years;
  // listQuery.cwkm = obj.cwkm;
  getDataList();
  // getTotaldata()
}
//ALL_查询安全投入列表
function getDataList() {
  tableloading.value = true
  // /ys/getDeptItem
  const deptid = props.row?.orgid
  const params = {
    pageCurrent: listQuery.pageCurrent,
    pageSize: listQuery.pageSize,
    deptid: deptid,
    years: props.years,
  }
  getApi(params, '/mosty-jcgl/ys/getDeptItem').then((res) => {
    if (res) {
      tableloading.value = false;
      tableData.value = Array.isArray(res?.records) ? res.records : [];
      tableData.value.forEach(async (item) => {
        item.budget = item.budget ? item.budget : 0;
        item.budgetmoney = item.budgetmoney ? item.budgetmoney : 0;
        item.tzzj = item.tzzj ? item.tzzj : 0;
        item.gkshzj = item.gkshzj ? item.gkshzj : 0;
        item.yeargkshzj = item.yeargkshzj ? item.yeargkshzj : 0;
        item.yeartzzj = item.yeartzzj ? item.yeartzzj : 0;
        item.pfjeall = numAdd("add", 4, item.budget, item.gkshzj, item.yeargkshzj)
        item.symoney = numAdd("reduce", 4, item.pfjeall, item.costFee);
      })
      pageConfiger.total = res.total;
    }
  }).catch((err) => {
    tableData.value = []
    tableloading.value = false;
  }).finally(() => {
    tableloading.value = false;
  })
}



//分页
const handleSizeChange = (currentSize) => {
  listQuery.pageSize = currentSize;
  pageConfiger.pageSize = currentSize;
  getDataList();
};
const handleCurrentChange = (currentPage) => {
  listQuery.pageCurrent = currentPage;
  pageConfiger.pageCurrent = currentPage;
  getDataList();
};


//导出Excel
function onloadExcel() {
  let title = {
    budgettitle: '预算项目',
    cwkm: '财务科目',
    ctype: '预算类别',
    orgname: '使用部门',
    costFee: '使用金额(万元)',
    symoney: '剩余金额(万元)',
    budgetmoney: '年初预算调整金额(万元)',
    budget: '年初批复',
    tzzj: '中期调整增减数',
    gkshzj: '中期归口审核增减数',
    state: '状态',
  }
  loadingShow.value = true
  const params = {
    pageCurrent: 1,
    pageSize:9999999,
    deptid: props.row?.orgid,
    years: props.years,
  }
  getApi(params, '/mosty-jcgl/ys/getDeptItem').then(async (res) => {
    if (res) {
      let data = Array.isArray(res?.records)? res?.records : [];
      if (data.length) {
        for (let i = 0; i < data.length; i++) {
          data[i].deptname = data[i].deptname || ''
          data[i].ctype = proxy.$getDictVal(data[i].ctype, D_BZ_YSFYLB);
          data[i].cwkm = proxy.$getDictVal(data[i].cwkm, D_TB_YSCWKU);
          data[i].budget = data[i].budget ? data[i].budget : 0
          data[i].budgetmoney = data[i].budgetmoney ? data[i].budgetmoney : 0
          data[i].tzzj = data[i].tzzj ? data[i].tzzj : 0
          data[i].gkshzj = data[i].gkshzj ? data[i].gkshzj : 0
          data[i].state = stateOpt.find(item => item.value == data[i].state)?.label || ''
          data[i].yeartzzj = data[i].yeartzzj ? data[i].yeartzzj : 0
          data[i].yeargkshzj = data[i].yeargkshzj ? data[i].yeargkshzj : 0
          data[i].pfjeall = numAdd("add", 4, data[i].budget, data[i].totalcost, data[i].yeargkshzj)
          let total =  data[i].budget +  data[i].tzzj +  data[i].gkshzj
          data[i].symoney = total - data[i].costFee
          data[i].symoney = Math.round(data[i].symoney * 10000) / 10000
        }
        let tablename = `${props.row.orgname}-详情.xlsx`
        exportXlsx(title, data, `${props.row.orgname}-详情`, tablename);
      } else {
        ElMessage.warning("暂无数据");
      }
    }

  }).finally(err => {
    loadingShow.value = false
  })
}
const seeDetail = (row) => {
    currRow.value = row
    isShowXgsTC.value = true
    xgsTCTitle.value = `${row.orgname}-查看详情`
}


</script>

<style lang="scss" scoped>
::v-deep .bigBox {
  height: initial;
}

::v-deep .bigBox .zy-right {
  margin-left: 0;
}

.btnBox {
  display: flex;
  align-items: center;
  justify-content: flex-end;
  margin-bottom: 12px;
}

.toggle {
  height: 40px;
  cursor: pointer;
  display: flex;
  align-items: center;
  color: #0f3916;

  .el-icon {
    transform: rotate(90deg);
    transition: all 0.25s ease;
  }

  &.active {
    .el-icon {
      transform: rotate(-90deg);
    }
  }
}
</style>
